<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.tm.TFRules']}"/>
    <ui:define name="body">
        <h:form id="rulesForm" styleClass="form-horizontal">
            <s:token allowMultiplePosts="true"/>
            <s:div rendered="#{s:hasPermission('MasterModel', 'edit', null)}">
            </s:div>
            #{aipoSelector.setTestingSession(null)}
            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <ui:include src="/filter/filter.xhtml">
                    <ui:param name="filter" value="#{aipoSelector.filter}"/>
                    <ui:param name="filterWidth" value="240"/>
                    <ui:param name="filterId" value="integrationProfile"/>
                    <ui:param name="filterName" value="#{messages['gazelle.tf.integrationProfile']}"/>
                    <ui:param name="filterForm" value="rulesForm"/>
                </ui:include>
                <!-- integrationProfileOption -->
                <ui:include src="/filter/filter.xhtml">
                    <ui:param name="filter" value="#{aipoSelector.filter}"/>
                    <ui:param name="filterWidth" value="240"/>
                    <ui:param name="filterId" value="integrationProfileOption"/>
                    <ui:param name="filterName"
                              value="#{messages['gazelle.tests.test.integrationProfileOption']}"/>
                    <ui:param name="filterForm" value="rulesForm"/>
                </ui:include>
                <!-- actor -->
                <ui:include src="/filter/filter.xhtml">
                    <ui:param name="filter" value="#{aipoSelector.filter}"/>
                    <ui:param name="filterWidth" value="240"/>
                    <ui:param name="filterId" value="actor"/>
                    <ui:param name="filterName"
                              value="#{messages['gazelle.testmanagement.object.Actor']}"/>
                    <ui:param name="filterForm" value="rulesForm"/>
                </ui:include>
                <ui:define name="filter_buttons">
                    <a4j:commandLink actionListener="#{aipoSelector.filter.clear()}"
                                     title="#{messages['gazelle.users.reset']}" type="submit"
                                     execute="@this" render="rulesForm">
                        <span class="fa fa-times-circle"/>
                    </a4j:commandLink>
                </ui:define>
            </ui:decorate>
            <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.AddNew']}"
                               actionListener="#{rulesManager.addNew()}"
                               styleClass="gzl-btn-green"/>
            <h:commandLink title="#{messages['net.ihe.gazelle.tm.DownloadFilteredTFRulesAsXmlFile']}"
                           ignoreDupResponses="true"
                           action="#{rulesManager.exportRulesAsXml()}"
                           rendered="#{s:hasRole('admin_role')}"
                           value ="#{messages['net.ihe.gazelle.tm.ExportFilteredTFRules']}"
                           styleClass="gzl-btn-blue pull-right"
                           execute="@this"/>
            <rich:dataTable id="rulesTable" var="currentValue" value="#{rulesManager.aipoR}" rowKeyVar="rowNumber"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="ds">
                <g:column>
                    <ui:define name="header">#{messages['gazelle.testmanagement.object.Name']}</ui:define>
                    <h:outputText value="#{currentValue.name}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['gazelle.testmanagement.object.Comment']}</ui:define>
                    <h:outputText value="#{currentValue.comment}"/>
                </g:column>
                <g:column rendered="#{applicationManager.isAssertionEnabled()}">
                    <ui:define name="header"># #{messages['net.ihe.gazelle.tm.OfAssertionsLinked']}</ui:define>
                    <h:outputText value="#{rulesManager.getNbAssertionsFor(currentValue.id)}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['gazelle.tf.table.Action']}</ui:define>
                    <div class="gzl-never-wrap">

                        <a4j:commandLink actionListener="#{rulesManager.view(currentValue)}"
                                         oncomplete="jq162('#ViewRule').modal('show')"
                                         title="#{messages['gazelle.common.button.View']}"
                                         render="viewRuleC">
                            <span class="gzl-icon-search"/>
                        </a4j:commandLink>

                        <a4j:commandLink action="#{rulesManager.edit(currentValue)}"
                                         title="#{messages['gazelle.common.button.Edit']}"
                                         rendered="#{s:hasPermission('MasterModel', 'edit', null)}">
                            <span class="gzl-icon-pencil"/>
                        </a4j:commandLink>

                        <a4j:commandLink oncomplete="jq162('#DeleteRule').modal('show')"
                                         title="#{messages['gazelle.common.button.Delete']}"
                                         rendered="#{s:hasPermission('MasterModel', 'edit', null)}"
                                         execute="@this"
                                         actionListener="#{rulesManager.preDelete(currentValue)}">
                            <span class="gzl-icon-trash-o"/>
                        </a4j:commandLink>

                    </div>
                </g:column>
                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="ds"/>
                        <ui:param name="dataTableId" value="rulesTable"/>
                    </ui:include>
                </f:facet>
            </rich:dataTable>

            <s:div id ="importDiv" rendered="#{(s:hasRole('admin_role'))}">
                <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                    <ui:param name="panel_id" value="importPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.ImportTFRules']}"/>
                    </ui:define>

                    <s:div id="uploadFile" rendered="#{rulesManager.aipoRulesToImport == null}">
                        <s:div rendered="#{rulesManager.getUploadedFileContent() == null}">
                            <h:outputText id="fileUploadInfo"
                                          value="#{messages['net.ihe.gazelle.tm.PleaseUploadTheXMLFileContainingTFRulesToImportH']}"/>
                            <ul>
                                <li>
                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.ActorIntegrationProfileOptionDetectionIsBasedOnK_2']}"/>
                                </li>
                                <li>
                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.IfAandOrorListOfCriterionGetsDownToOneElementItW']}"/>
                                </li>
                                <li>
                                    <h:outputText value="#{messages['net.ihe.gazelle.tm.IfARuleMissEitherACauseOrAConsequenceCriterionIt']}"/>
                                </li>
                            </ul>
                            <rich:fileUpload
                                    fileUploadListener="#{rulesManager.uploadListener}"
                                    maxFilesQuantity="1"
                                    listHeight="60px"
                                    immediateUpload="true">
                                <a4j:ajax event="uploadcomplete" render="uploadFile, footer"/>
                            </rich:fileUpload>
                        </s:div>

                        <s:div id="fileNameInfo" rendered="#{rulesManager.getUploadedFileContent() != null}" styleClass="form-horizontal">

                            <s:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">
                                    <h:outputText  value="#{messages['net.ihe.gazelle.tm.TFRuleFile']}"/>
                                </ui:define>
                                <h:outputText value="#{rulesManager.getDescription()}"  />
                            </s:decorate>

                        </s:div>

                        <s:div id="reviewDiv">
                            <s:decorate template="/layout/form/_checkbox.xhtml">
                                <ui:param name="id" value="cbAutoImport"/>
                                <ui:define name="label">
                                    <h:outputText  value="#{messages['net.ihe.gazelle.tm.ReviewChangesBeforeSaving']}"/>
                                </ui:define>
                                <h:selectBooleanCheckbox id="cbAutoImport" value="#{rulesManager.reviewBeforeSaving}">
                                    <a4j:ajax event="change" render="reviewDiv"/>
                                </h:selectBooleanCheckbox>
                            </s:decorate>

                            <s:div rendered="#{not rulesManager.reviewBeforeSaving}">
                                <br/>
                                <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                <h:outputText id="cbAutoImport"
                                              class="gzl-text-orange"
                                              value="#{messages['net.ihe.gazelle.tm.TheImportedTFRulesWillBePersistedInDatabaseWitho']}"/>
                            </s:div>
                        </s:div>

                    </s:div>

                    <s:div id="reportDiv" rendered="#{rulesManager.aipoRulesToImport != null}" >
                        <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                            <ui:param name="panel_id" value="reportPanel"/>
                            <ui:define name="panel_title">
                                <h:outputText value="#{messages['net.ihe.gazelle.tm.ReportOnTFRulesImport']}"/>
                            </ui:define>

                            <s:div id="reportBody" rendered="#{rulesManager.aipoRulesToImport != null}" >
                                <div class="panel-body bg-primary">
                                    <s:div rendered="#{rulesManager.aipoRulesToImport.ignoredRules != null}">
                                        <h:outputText value="#{rulesManager.aipoRulesToImport.ignoredRules.size} #{messages['net.ihe.gazelle.tm.TFRulesWillBeIgnoredBecauseTheyAreMissingTooMuch']}" style="font-weight:bold"/>
                                        <br/>
                                        <s:div rendered="#{not rulesManager.aipoRulesToImport.ignoredRules.isEmpty()}">
                                            <h:outputText value="#{messages['net.ihe.gazelle.tm.HereIsTheListOfTFRulesThatHaveBeenIgnored']} "/>
                                            <ul>
                                                <ui:repeat value="#{rulesManager.aipoRulesToImport.ignoredRules}" var="rule">
                                                    <li>
                                                        <h:outputText value="#{rule}"/>
                                                    </li>
                                                </ui:repeat>
                                            </ul>
                                        </s:div>
                                    </s:div>

                                    <s:div styleClass="col-md-4" rendered="#{rulesManager.aipoRulesToImport.unknownActors != null}">
                                        <h:outputText value="#{rulesManager.aipoRulesToImport.unknownActors.size} #{messages['net.ihe.gazelle.tm.ActorsHaveBeenFoundMissingInThisInstance']}" style="font-weight:bold"/>
                                        <br/>
                                        <s:div rendered="#{not rulesManager.aipoRulesToImport.unknownActors.isEmpty()}">
                                            <h:outputText value="#{messages['net.ihe.gazelle.tm.HereIsTheListOfActorsThatHaveBeenFoundMissing']} "/>
                                            <ul>
                                                <ui:repeat value="#{rulesManager.aipoRulesToImport.unknownActors}" var="actor">
                                                    <li>
                                                        <h:outputText value="#{actor}"/>
                                                    </li>
                                                </ui:repeat>
                                            </ul>
                                        </s:div>
                                    </s:div>

                                    <s:div styleClass="col-md-4" rendered="#{rulesManager.aipoRulesToImport.unknownIntegrationProfiles != null}">
                                        <h:outputText value="#{rulesManager.aipoRulesToImport.unknownIntegrationProfiles.size} #{messages['net.ihe.gazelle.tm.IntegrationProfilesHaveBeenFoundMissingInThisIns']}" style="font-weight:bold"/>
                                        <br/>
                                        <s:div rendered="#{not rulesManager.aipoRulesToImport.unknownIntegrationProfiles.isEmpty()}">
                                            <h:outputText value="#{messages['net.ihe.gazelle.tm.HereIsTheListOfIntegrationProfilesThatHaveBeenFo']} "/>
                                            <ul>
                                                <ui:repeat value="#{rulesManager.aipoRulesToImport.unknownIntegrationProfiles}" var="ip">
                                                    <li>
                                                        <h:outputText value="#{ip}"/>
                                                    </li>
                                                </ui:repeat>
                                            </ul>
                                        </s:div>
                                    </s:div>

                                    <s:div styleClass="col-md-4" rendered="#{rulesManager.aipoRulesToImport.unknownOptions != null}">
                                        <h:outputText value="#{rulesManager.aipoRulesToImport.unknownOptions.size} #{messages['net.ihe.gazelle.tm.OptionsHaveBeenFoundMissingInThisInstance']}" style="font-weight:bold"/>
                                        <br/>
                                        <s:div rendered="#{not rulesManager.aipoRulesToImport.unknownOptions.isEmpty()}">
                                            <h:outputText value="#{messages['net.ihe.gazelle.tm.HereIsTheListOfOptionsThatHaveBeenFoundMissing']} "/>
                                            <ul>
                                                <ui:repeat value="#{rulesManager.aipoRulesToImport.unknownOptions}" var="option">
                                                    <li>
                                                        <h:outputText value="#{option}"/>
                                                    </li>
                                                </ui:repeat>
                                            </ul>
                                        </s:div>
                                    </s:div>
                                </div>
                                <br/>
                                <s:div rendered="#{rulesManager.aipoRulesToImport.aipoRules != null and rulesManager.reviewBeforeSaving}">
                                    <h:outputText value="#{rulesManager.aipoRulesToImport.aipoRules.size} #{messages['net.ihe.gazelle.tm.TFRulesWillBeImportedIntoYourDatabase']}" style="font-weight:bold"/>
                                </s:div>
                                <s:div rendered="#{rulesManager.aipoRulesToImport.aipoRules != null and not rulesManager.reviewBeforeSaving}">
                                    <h:outputText value="#{rulesManager.aipoRulesToImport.aipoRules.size} #{messages['net.ihe.gazelle.tm.TFRulesHaveBeenImportedIntoYourDatabase']}" style="font-weight:bold"/>
                                </s:div>

                                <s:div rendered="#{not (rulesManager.aipoRulesToImport.aipoRules == null) and not rulesManager.aipoRulesToImport.aipoRules.isEmpty()}">
                                    <div class="panel-body">
                                        <rich:dataTable id="rulesToImportTable" var="currentValue" value="#{rulesManager.aipoRulesToImport.aipoRules}"
                                                        rowKeyVar="rowNumber" rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="dsImport">
                                            <g:column>
                                                <ui:define name="header">#{messages['gazelle.testmanagement.object.Name']}</ui:define>
                                                <h:outputText value="#{currentValue.name}"/>
                                            </g:column>
                                            <g:column>
                                                <ui:define name="header">#{messages['gazelle.testmanagement.object.Comment']}</ui:define>
                                                <h:outputText value="#{currentValue.comment}"/>
                                            </g:column>
                                            <f:facet name="footer">
                                                <ui:include src="/util/datatableFooter.xhtml">
                                                    <ui:param name="dataScrollerId" value="dsImport"/>
                                                    <ui:param name="dataTableId" value="rulesToImportTable"/>
                                                </ui:include>
                                            </f:facet>
                                        </rich:dataTable>
                                    </div>
                                </s:div>

                                <s:div rendered="#{rulesManager.aipoRulesToImport.duplicatedRules != null and rulesManager.reviewBeforeSaving}">
                                    <h:outputText value="#{rulesManager.aipoRulesToImport.duplicatedRules.size} #{messages['net.ihe.gazelle.tm.TFRulesAreAlreadyPresentInYourDatabaseAndWontBeI']}" style="font-weight:bold"/>
                                </s:div>
                                <s:div rendered="#{rulesManager.aipoRulesToImport.duplicatedRules != null and not rulesManager.reviewBeforeSaving}">
                                    <h:outputText value="#{rulesManager.aipoRulesToImport.duplicatedRules.size} #{messages['net.ihe.gazelle.tm.TFRulesHaveNotBeenImportedIntoYourDatabaseBecaus']}" style="font-weight:bold"/>
                                </s:div>

                                <s:div rendered="#{not (rulesManager.aipoRulesToImport.duplicatedRules == null) and not rulesManager.aipoRulesToImport.duplicatedRules.isEmpty()}">
                                    <div class="panel-body">
                                        <rich:dataTable id="duplicateRulesTable" var="currentValue" value="#{rulesManager.aipoRulesToImport.duplicatedRules}"
                                                        rowKeyVar="rowNumber" rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="dsDuplicate">
                                            <g:column>
                                                <ui:define name="header">#{messages['gazelle.testmanagement.object.Name']}</ui:define>
                                                <h:outputText value="#{currentValue.name}"/>
                                            </g:column>
                                            <g:column>
                                                <ui:define name="header">#{messages['gazelle.testmanagement.object.Comment']}</ui:define>
                                                <h:outputText value="#{currentValue.comment}"/>
                                            </g:column>
                                            <f:facet name="footer">
                                                <ui:include src="/util/datatableFooter.xhtml">
                                                    <ui:param name="dataScrollerId" value="dsDuplicate"/>
                                                    <ui:param name="dataTableId" value="duplicateRulesTable"/>
                                                </ui:include>
                                            </f:facet>
                                        </rich:dataTable>
                                    </div>
                                </s:div>
                            </s:div>

                            <ui:define name="panel_footer">
                                <s:div id="reportFooter">
                                    <a4j:commandButton styleClass="gzl-btn"
                                                       value="#{messages['net.ihe.gazelle.tm.Reset']}"
                                                       rendered="#{rulesManager.getUploadedFileContent() != null}"
                                                       actionListener="#{rulesManager.resetImport()}"
                                                       render="importDiv"
                                                       execute="@this"/>

                                    <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.ImportTFRules']}"
                                                       rendered="#{rulesManager.getUploadedFileContent() != null and rulesManager.reviewBeforeSaving and not rulesManager.aipoRulesToImport.isImported()}"
                                                       styleClass="gzl-btn-blue"
                                                       action="#{rulesManager.persistImportedRules()}"
                                                       render="rulesTable,importDiv"/>
                                </s:div>
                            </ui:define>
                        </ui:decorate>
                    </s:div>


                    <ui:define name="panel_footer">
                        <s:div id="footer">
                            <a4j:commandButton styleClass="gzl-btn"
                                               value="#{messages['net.ihe.gazelle.tm.Reset']}"
                                               rendered="#{(rulesManager.getUploadedFileContent() != null) and (rulesManager.aipoRulesToImport == null)}"
                                               actionListener="#{rulesManager.resetUpload()}"
                                               render="importDiv"
                                               execute="@this"/>

                            <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.ImportTFRules']}"
                                               rendered="#{(rulesManager.getUploadedFileContent() != null) and (rulesManager.aipoRulesToImport == null)}"
                                               styleClass="gzl-btn-blue"
                                               action="#{rulesManager.importTFRulesFromXml()}"
                                               render="rulesTable,importDiv"/>
                        </s:div>
                    </ui:define>
                </ui:decorate>
            </s:div>

        </h:form>
        <h:form id="deletefrm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title.xhtml">
                <ui:param name="popup_id" value="DeleteRule"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.tm.DeleteRule']}</ui:define>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.DeleteRule']}"
                                   styleClass="gzl-btn-red" actionListener="#{rulesManager.delete()}"
                                   oncomplete="jq162('#DeleteRule').modal('hide')"
                                   render="rulesForm"/>
                <a4j:commandButton value="#{messages['gazelle.common.button.Cancel']}"
                                   onclick="jq162('#DeleteRule').modal('hide')"
                                   styleClass="gzl-btn"/>
            </ui:decorate>
        </h:form>
        <h:form id="ViewRuleForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title.xhtml">
                <ui:param name="popup_id" value="ViewRule"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.tm.ViewRule']}</ui:define>
                <s:div id="viewRuleC">
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.testmanagement.object.Name']}</ui:define>
                        <h:outputText value="#{rulesManager.editedItem.name}"/>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.tm.Cause']}</ui:define>
                        <s:decorate template="/tf/rules/criterionView.xhtml">
                            <ui:param name="criterion" value="#{rulesManager.editedItem.cause}"/>
                        </s:decorate>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.tm.Consequence']}</ui:define>
                        <s:decorate template="/tf/rules/criterionView.xhtml">
                            <ui:param name="criterion" value="#{rulesManager.editedItem.consequence}"/>
                        </s:decorate>
                    </s:decorate>
                    <s:decorate template="/layout/display/_display.xhtml">
                        <ui:define name="label">#{messages['gazelle.testmanagement.object.Comment']}</ui:define>
                        <h:outputText value="#{rulesManager.editedItem.comment}"/>
                    </s:decorate>
                    <br/>
                    <s:div rendered="#{applicationManager.isAssertionEnabled()}">
                        <ui:include src="/testing/testsDefinition/viewAssertions.xhtml">
                            <ui:param name="assertions"
                                      value="#{assertionsManager.getRuleAssertions(rulesManager.editedItem.id)}"/>
                        </ui:include>
                    </s:div>
                </s:div>
            </ui:decorate>



        </h:form>

    </ui:define>
</ui:composition>
